bzoj1059题解

【解题思路】

  因为只要验证可行性,所以考虑行和考虑列是等价的,故我们只考虑行的交换操作。

  这样,拆一波点,把每一行拆成两个点,左边为原交换行,右边为目标交换行,原问题等价于能否对这个二分图进行完全匹配,题中给定邻接矩阵即为二分图的邻接矩阵。

  于是直接匈牙利一波,复杂度O(n3)。

【参考代码】

 1 #include <cctype>
 2 #include <cstdio>
 3 #define REP(I,low,high) for(register int I=(low);I<=(high);I++)
 4 #define PER(I,high,low) for(register int I=(high);I>=(low);I--)
 5 inline int getint()
 6 {
 7     char ch=getchar();
 8     for(;!isdigit(ch)&&ch!=‘+‘&&ch!=‘-‘;ch=getchar());
 9     bool impositive=ch==‘-‘;
10     if(impositive)
11         ch=getchar();
12     int result=0;
13     for(;isdigit(ch);ch=getchar())
14         result=(result<<3)+(result<<1)+ch-‘0‘;
15     return impositive?-result:result;
16 }
17 template<typename integer> inline int write(integer n)
18 {
19     integer now=n;
20     bool impositive=now<0;
21     if(impositive)
22     {
23         putchar(‘-‘);
24         now=-now;
25     }
26     char sav[40];
27     sav[0]=now%10+‘0‘;
28     int result=1;
29     for(;now/=10;sav[result++]=now%10+‘0‘);
30     PER(i,result-1,0)
31         putchar(sav[i]);
32     return result+impositive;
33 }
34 //Header Template
35 #include <cstring>
36 bool used[210],map[210][210];
37 int n,result[210];
38 bool find(int S)
39 {
40     REP(T,1,n)
41         if(map[S][T]&&!used[T])
42         {
43             used[T]=true;
44             if(!result[T]||find(result[T]))
45             {
46                 result[T]=S;
47                 return true;
48             }
49         }
50     return false;
51 }
52 int main()
53 {
54     for(int T=getint();T--;)
55     {
56         n=getint();
57         REP(i,1,n)
58             REP(j,1,n)
59                 map[i][j]=getint();
60         memset(result,0,sizeof(result));
61         int ans=0;
62         REP(i,1,n)
63         {
64             memset(used,0,sizeof(used));
65             ans+=find(i);
66         }
67         puts(ans==n?"Yes":"No");
68     }
69     return 0;
70 }

时间: 2024-11-03 21:53:32

bzoj1059题解的相关文章

BZOJ1059:[ZJOI2007]矩阵游戏——题解

http://www.lydsy.com/JudgeOnline/problem.php?id=1059 https://www.luogu.org/problemnew/show/P1129 小Q是一个非常聪明的孩子,除了国际象棋,他还很喜欢玩一个电脑益智游戏――矩阵游戏.矩阵游戏在一个N*N黑白方阵进行(如同国际象棋一般,只是颜色是随意的).每次可以对该矩阵进行两种操作: 行交换操作:选择矩阵的任意两行,交换这两行(即交换对应格子的颜色) 列交换操作:选择矩阵的任意两列,交换这两列(即交换对

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ